import pygame
from pygame.locals import *

class Box(pygame.sprite.Sprite):
    def __init__(self, color, initial_position, fps):
        pygame.sprite.Sprite.__init__(self)
        self.act_frame = 0
        self.create_images(color) # create the images for the animation
        self.rect = self.image.get_rect()
        self.rect.topleft = initial_position
        self.fps = fps
        self.change_time = 1.0/self.fps
        print self.change_time
        self.time = 0

    def create_images(self,color):
        self.frames = []
        # create a transparent surface
        image = pygame.Surface((20,20),pygame.SRCALPHA,32)
        pygame.draw.rect(image,color,(0,0,10,10))
        self.frames.append(image)
        image = pygame.Surface((20,20),pygame.SRCALPHA,32)
        pygame.draw.rect(image,color,(10,0,10,10))
        self.frames.append(image)
        image = pygame.Surface((20,20),pygame.SRCALPHA,32)
        pygame.draw.rect(image,color,(0,10,10,10))
        self.frames.append(image)
        image = pygame.Surface((20,20),pygame.SRCALPHA,32)
        pygame.draw.rect(image,color,(10,10,10,10))
        self.frames.append(image)
        self.image = self.frames[self.act_frame]

    def update(self, time_passed):
        self.time += time_passed
        if self.time >= self.change_time:
            self.act_frame = (self.act_frame + 1) % len(self.frames)
            self.image = self.frames[self.act_frame]
            self.time = 0

pygame.init()

screen = pygame.display.set_mode((640, 480), 0, 32)
box1 = Box((255,0,0),(0,0),4)
box2 = Box((0,100,255),(40,40),2)
clock = pygame.time.Clock()

while True:
    for event in pygame.event.get():
        if event.type == QUIT:
            exit()
    screen.fill((100, 200, 0))
    time_passed = clock.tick() / 1000.0
    box1.update(time_passed)
    screen.blit(box1.image,box1.rect)
    box2.update(time_passed)
    screen.blit(box2.image,box2.rect)
    pygame.display.update()
